#include "Header.h"
#include <string>


void createData(const std::string& file)
{
    srand(time(0));
    std::ofstream of;
    of.open(file);

    std::ostream_iterator<int> iter(of, " ");

    for (int i = 0; i < 100; i++)
    {
        (*iter) = rand() % 100 - 50;
        iter++;
    }
    
    of.close();
}

void _createData(const std::string& file)
{
    srand(time(0));

    std::vector<int> vec(100);

    std::generate(vec.begin(), vec.end(), []() {
        return (rand() % 100 - 50); });

    std::ofstream of;
    of.open(file);

    std::ostream_iterator<int> iter(of," ");

    std::copy(vec.begin(), vec.end(), iter);


}

void modify_2(std::istream_iterator<int> first, std::istream_iterator<int> last)
{
    std::vector<int> vec;
    std::copy(first, last, std::back_inserter(vec));
 
    int max = *(std::max_element(vec.begin(), vec.end()));

    for (auto& el : vec)
        if (el > 0)
            el = max;

   
    std::ofstream newFile("new.txt");
    std::ostream_iterator<int> iter(newFile, " ");

    std::copy(vec.begin(), vec.end(), iter);

    newFile.close();
}

void modify_3(const std::string& file)
{
    std::vector<int> vec = _loadData<std::vector<int>>(file);

    int max = *(std::max_element(vec.begin(), vec.end()));

    std::for_each(vec.begin(), vec.end(), [&max](int& p_a) {
        if (p_a > 0)
            p_a = max;
        });

    std::ofstream newFile("new.txt");
    std::ostream_iterator<int> iter(newFile, " ");

    std::copy(vec.begin(), vec.end(), iter);

    newFile.close();

    remove(file.c_str());
    rename("new.txt", file.c_str());
}

void modify_4(const std::string& fileName)
{
    std::ifstream i_f(fileName);

    std::istream_iterator<int> begin(i_f);
    std::istream_iterator<int> end;


    int max = *(std::max_element(begin, end));

    i_f.close();
    i_f.open(fileName);
    std::istream_iterator<int> _begin(i_f);
    std::istream_iterator<int> _end;

    std::ofstream of("new.txt");
    std::ostream_iterator<int> ofIter(of, " ");
    
    std::transform(_begin, _end, ofIter, [&max](int p_a) {
        if (p_a > 0)
            return max;
        else
            return p_a;
        });

    i_f.close();
    of.close();

    remove(fileName.c_str());
    rename("new.txt", fileName.c_str());
}


